//+------------------------------------------------------------------+
//|                                   MultiSymbolPriceDivergence.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window //    
#property indicator_buffers 25   //     
#property indicator_plots   5    //   
//---
#property indicator_color1  clrDodgerBlue,C'0,50,100'
#property indicator_color2  clrLimeGreen,C'20,80,20'
#property indicator_color3  clrGold,C'160,140,0'
#property indicator_color4  clrAqua,C'0,140,140'
#property indicator_color5  clrMagenta,C'130,0,130'
//---  
#define RESET           0 //      
#define SYMBOLS_COUNT   5 //  
//---      
#include <Canvas\Canvas.mqh>
//---   
#include "../Include/Checks.mqh"
#include "../Include/Chart.mqh"
#include "../Include/Objects.mqh"
//---    
enum ENUM_DRAWTYPE
  {
   LINE   =0,  // 
   BARS   =1,  // 
   CANDLES=2   //  
  };
//---     
enum ENUM_START_POINT
  {
   VERTICAL_LINE=0,  //  
   MONTH        =1,  // 
   WEEK         =2,  // 
   DAY          =3,  // 
   HOUR         =4   // 
  };
//---  
input  ENUM_DRAWTYPE    DrawType             =CANDLES;       //  
input  ENUM_START_POINT StartPriceDivergence =VERTICAL_LINE; //   
input  bool             TwoColor             =false;         //  /
sinput string dlm01=""; //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
input  string           Symbol02             ="GBPUSD";      //  2
input  bool             Inverse02            =false;         //   2
input  string           Symbol03             ="AUDUSD";      //  3
input  bool             Inverse03            =false;         //   3
input  string           Symbol04             ="NZDUSD";      //  4
input  bool             Inverse04            =false;         //   4
input  string           Symbol05             ="USDCAD";      //  5
input  bool             Inverse05            =false;         //   5
input  string           Symbol06             ="USDCHF";      //  6
input  bool             Inverse06            =false;         //   6
//---    
struct buffers
  {
   double            open[];   //    
   double            high[];   //    
   double            low[];    //    
   double            close[];  //    
   double            icolor[]; //     
  };
buffers           buffer_data[SYMBOLS_COUNT];
//---  
CCanvas           canvas;
//--- /     OnCalculate()
int               OC_rates_total     =0; //   
int               OC_prev_calculated =0; //     
datetime          OC_time[];             //  
double            OC_open[];             //  
double            OC_high[];             //  
double            OC_low[];              //  
double            OC_close[];            //  
long              OC_tick_volume[];      //  
long              OC_volume[];           //  
int               OC_spread[];           // 

//---         
datetime          series_first_date[SYMBOLS_COUNT];
datetime          series_first_date_last[SYMBOLS_COUNT];
//---   ,    
datetime          limit_time[SYMBOLS_COUNT];
//---   
string            symbol_names[SYMBOLS_COUNT];
//---    
bool              inverse[SYMBOLS_COUNT];
//---   
color             line_colors[SYMBOLS_COUNT]={clrDodgerBlue,clrLimeGreen,clrGold,clrAqua,clrMagenta};
//--- ,   
string            empty_symbol="EMPTY";
//---  
int               window_number              =WRONG_VALUE;               //   
int               chart_width                =0;                         //  
int               chart_height               =0;                         //  
int               last_chart_width           =0;                         //     
int               last_chart_height          =0;                         //     
int               chart_center_x             =0;                         //    
int               chart_center_y             =0;                         //    
color             color_bar_up               =clrRed;                    //   
color             color_bar_down             =C'100,0,0';                //   
string            indicator_shortname        ="MS_PriceDivergence";      //   
string            prefix                     =indicator_shortname+"_";   //   
//---       
string            start_price_divergence=prefix+"start_price_divergence";
//---  
string            canvas_name             =prefix+"canvas";          //  
color             canvas_background       =clrBlack;                 //   
uchar             canvas_opacity          =190;                      //  
int               font_size               =16;                       //  
string            font_name               ="Calibri";                // 
ENUM_COLOR_FORMAT clr_format              =COLOR_FORMAT_ARGB_RAW;    //       
//---  
string            msg_prepare_data        =" ! , ...";
string            msg_not_synchronized    ="  ! , ...";
string            msg_load_data           ="";
string            msg_sync_update         ="";
string            msg_last                ="";
//---
ENUM_TIMEFRAMES   timeframe_start_point  =Period();    //     
datetime          first_period_time      =NULL;        //       
double            divergence_price       =0.0;         //     
datetime          divergence_time        =NULL;        //     
double            symbol_difference[SYMBOLS_COUNT];    //      
double            inverse_difference[SYMBOLS_COUNT];   // ,     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- ,       
   if(!CheckTesterMode())
      return(INIT_FAILED);
//---   /
   SetBarsColors();
//---       
   InitStartPointTF();
//---    
   if(!CheckInputParameters())
      return(INIT_PARAMETERS_INCORRECT);
//---     1 
   EventSetMillisecondTimer(1000);
//---      
   canvas.FontSet(font_name,font_size,FW_NORMAL);
//---  
   InitArrays();
//---    
   InitSymbolNames();
//---   
   InitInverse();
//---   
   SetIndicatorProperties();
//---      
   SetDivergenceLine();
//---  
   Comment("");
//---  
   ChartRedraw();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(reason==REASON_REMOVE      || //      
      reason==REASON_CHARTCHANGE || //      
      reason==REASON_RECOMPILE   || //    
      reason==REASON_CHARTCLOSE  || //    
      reason==REASON_CLOSE       || //    
      reason==REASON_PARAMETERS)    //   
     {
      //---  
      EventKillTimer();
      //---   
      DeleteVerticalLines();
      //---  
      DeleteCanvas();
      //---  
      ChartSetInteger(0,CHART_SCALEFIX,false);
      //---  
      Comment("");
     }
//---  
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int      rates_total,     //   
                const int      prev_calculated, //     
                const datetime &time[],         //  
                const double   &open[],         //  
                const double   &high[],         //  
                const double   &low[],          //  
                const double   &close[],        //  
                const long     &tick_volume[],  //  
                const long     &volume[],       //  
                const int      &spread[])       // 
  {
//---   ,     
   int limit=0;
//---    OnCalculate()
   CopyDataOnCalculate(rates_total,prev_calculated,
                       time,open,high,low,close,
                       tick_volume,volume,spread);
//---              
   if(prev_calculated==0)
     {
      //---   
      ZeroIndicatorBuffers();
      //---    
      GetWindowGeometry();
      //---  
      SetCanvas();
      //---    /  
      LoadAndFormData();
      LoadAndFormDataHighTF();
      //---       
      if(!CheckAvailableData())
         return(RESET);
      //--- ,     
      if(!CheckLoadedHistory())
         return(RESET);
      //---     /   
      if(!CheckSymbolIsSynchronized())
         return(RESET);
      //---    ,     
      if(!DetermineFirstTrueBar())
         return(RESET);
      //---     ,  OnCalculate()   ,    
      OC_prev_calculated=rates_total;
     }
//---      
   else
      limit=prev_calculated-1;

//---   
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      //---    , 
      if(symbol_names[s]!=empty_symbol)
        {
         //---    
         msg_last=msg_sync_update="  : "+
                  symbol_names[s]+"("+IntegerToString(s+1)+"/"+IntegerToString(SYMBOLS_COUNT)+") ... ";
         ShowCanvasMessage(msg_sync_update);
         //---    
         for(int i=limit; i<rates_total; i++)
           {
            FillIndicatorBuffers(i,s,time);
            //---  2000    ,    ,     
            if(!(i%2000))
               OnSubwindowChange();
           }
        }
     }
//---     
   CorrectChartMaxMin();
//---  
   DeleteCanvas();
//---   
   msg_last="";
   msg_sync_update="";
//---  
   ChartRedraw();
//---      
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---   
   if(!CheckEmptyValues())
      OC_prev_calculated=0;
//---      
   if(!CheckLoadedHistory())
      OC_prev_calculated=0;

//---     
   OnCalculate(OC_rates_total,
               OC_prev_calculated,
               OC_time,
               OC_open,
               OC_high,
               OC_low,
               OC_close,
               OC_tick_volume,
               OC_volume,
               OC_spread);

//---     
//CheckLastEmptyValues(10);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---    
   if(id==CHARTEVENT_OBJECT_DRAG)
     {
      //---          ,   
      if(StartPriceDivergence==VERTICAL_LINE)
         OnCalculate(OC_rates_total,
                     0,
                     OC_time,
                     OC_open,
                     OC_high,
                     OC_low,
                     OC_close,
                     OC_tick_volume,
                     OC_volume,
                     OC_spread);
     }
//---          
   if(id==CHARTEVENT_CHART_CHANGE)
      //---          
      CorrectChartMaxMin();
  }
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
void InitStartPointTF()
  {
//---    , 
   if(StartPriceDivergence==VERTICAL_LINE)
      return;
//---   
   switch(StartPriceDivergence)
     {
      case MONTH : timeframe_start_point=PERIOD_MN1; break;
      case WEEK  : timeframe_start_point=PERIOD_W1;  break;
      case DAY   : timeframe_start_point=PERIOD_D1;  break;
      case HOUR  : timeframe_start_point=PERIOD_H1;  break;
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void InitArrays()
  {
   ArrayInitialize(limit_time,NULL);
   ArrayInitialize(symbol_difference,0.0);
   ArrayInitialize(inverse_difference,0.0);
   ArrayInitialize(series_first_date,NULL);
   ArrayInitialize(series_first_date_last,NULL);
//---
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      ArrayInitialize(buffer_data[s].open,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].high,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].low,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].close,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].icolor,EMPTY_VALUE);
     }
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void InitSymbolNames()
  {
   symbol_names[0]=AddSymbolToMarketWatch(Symbol02);
   symbol_names[1]=AddSymbolToMarketWatch(Symbol03);
   symbol_names[2]=AddSymbolToMarketWatch(Symbol04);
   symbol_names[3]=AddSymbolToMarketWatch(Symbol05);
   symbol_names[4]=AddSymbolToMarketWatch(Symbol06);
  }
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void InitInverse()
  {
   inverse[0]=Inverse02;
   inverse[1]=Inverse03;
   inverse[2]=Inverse04;
   inverse[3]=Inverse05;
   inverse[4]=Inverse06;
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void SetIndicatorProperties()
  {
//---   
   IndicatorSetString(INDICATOR_SHORTNAME,indicator_shortname);
//---   
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---        ,   
   if(DrawType==LINE)
     {
      for(int s=0; s<SYMBOLS_COUNT; s++)
         SetIndexBuffer(s,buffer_data[s].close,INDICATOR_DATA);
     }
//---         
//    /      
   else if(DrawType==BARS || DrawType==CANDLES)
     {
      for(int s=0; s<SYMBOLS_COUNT; s++)
        {
         static int buffer_number=0;
         SetIndexBuffer(buffer_number,buffer_data[s].open,INDICATOR_DATA);
         buffer_number++;
         SetIndexBuffer(buffer_number,buffer_data[s].high,INDICATOR_DATA);
         buffer_number++;
         SetIndexBuffer(buffer_number,buffer_data[s].low,INDICATOR_DATA);
         buffer_number++;
         SetIndexBuffer(buffer_number,buffer_data[s].close,INDICATOR_DATA);
         buffer_number++;
         SetIndexBuffer(buffer_number,buffer_data[s].icolor,INDICATOR_COLOR_INDEX);
         buffer_number++;
        }
     }
//---     
//         
   if(DrawType==LINE)
     {
      for(int s=0; s<SYMBOLS_COUNT; s++)
         PlotIndexSetString(s,PLOT_LABEL,symbol_names[s]+",Close");
     }
//---      /
//        ";"
   else if(DrawType==BARS || DrawType==CANDLES)
     {
      for(int s=0; s<SYMBOLS_COUNT; s++)
        {
         PlotIndexSetString(s,PLOT_LABEL,
                            symbol_names[s]+",Open;"+
                            symbol_names[s]+",High;"+
                            symbol_names[s]+",Low;"+
                            symbol_names[s]+",Close");
        }
     }
//---      
//    
   if(DrawType==LINE)
      for(int s=0; s<SYMBOLS_COUNT; s++)
         PlotIndexSetInteger(s,PLOT_DRAW_TYPE,DRAW_LINE);
//--- 
   if(DrawType==BARS)
      for(int s=0; s<SYMBOLS_COUNT; s++)
         PlotIndexSetInteger(s,PLOT_DRAW_TYPE,DRAW_COLOR_BARS);
//--- 
   if(DrawType==CANDLES)
      for(int s=0; s<SYMBOLS_COUNT; s++)
         PlotIndexSetInteger(s,PLOT_DRAW_TYPE,DRAW_COLOR_CANDLES);

//---       
//    
   if(DrawType==LINE)
      ChartSetInteger(0,CHART_MODE,CHART_LINE);
//--- 
   if(DrawType==BARS)
      ChartSetInteger(0,CHART_MODE,CHART_BARS);
//--- 
   if(DrawType==CANDLES)
      ChartSetInteger(0,CHART_MODE,CHART_CANDLES);

//---   
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetInteger(s,PLOT_LINE_WIDTH,1);
//---      
   if(DrawType==LINE)
      for(int s=0; s<SYMBOLS_COUNT; s++)
         PlotIndexSetInteger(s,PLOT_LINE_COLOR,line_colors[s]);
//---         
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      if(symbol_names[s]!=empty_symbol)
         PlotIndexSetInteger(s,PLOT_SHOW_DATA,true);
      else
         PlotIndexSetInteger(s,PLOT_SHOW_DATA,false);
     }
//---    ,    
   for(int s=0; s<SYMBOLS_COUNT; s++)
      PlotIndexSetDouble(s,PLOT_EMPTY_VALUE,EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|    OnCalculate                                   |
//+------------------------------------------------------------------+
void CopyDataOnCalculate(const int      rates_total,
                         const int      prev_calculated,
                         const datetime &time[],
                         const double   &open[],
                         const double   &high[],
                         const double   &low[],
                         const double   &close[],
                         const long     &tick_volume[],
                         const long     &volume[],
                         const int      &spread[])
  {
   OC_rates_total=rates_total;
   OC_prev_calculated=prev_calculated;
   ArrayCopy(OC_time,time);
   ArrayCopy(OC_open,open);
   ArrayCopy(OC_high,high);
   ArrayCopy(OC_low,low);
   ArrayCopy(OC_close,close);
   ArrayCopy(OC_tick_volume,tick_volume);
   ArrayCopy(OC_volume,volume);
   ArrayCopy(OC_spread,spread);
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void ZeroIndicatorBuffers()
  {
   for(int s=0; s<SYMBOLS_COUNT; s++)
     {
      ArrayInitialize(buffer_data[s].open,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].high,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].low,EMPTY_VALUE);
      ArrayInitialize(buffer_data[s].close,EMPTY_VALUE);
     }
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void FillIndicatorBuffers(int i,int s,datetime const &time[])
  {
   MqlRates    rates[];             //  
   double      period_open[];       //        
   datetime    period_time[];       //     
   int         attempts=100;        //   
   datetime    high_tf_time=NULL;   //    

//---     ""  , 
   if(time[i]<limit_time[s])
      return;
//---   
   ResetLastError();
//---      
   for(int j=0; j<attempts; j++)
      if(CopyRates(symbol_names[s],Period(),time[i],1,rates)==1)
        { ResetLastError(); break; }
//---     , 
   if(ArraySize(rates)<1 || GetLastError()!=0)
      return;
//---    ,     
//            
//      
   if(rates[0].time==NULL || 
      time[i]!=rates[0].time || 
      time[i]<first_period_time || 
      rates[0].low==EMPTY_VALUE || 
      rates[0].open==EMPTY_VALUE ||
      rates[0].high==EMPTY_VALUE ||
      rates[0].close==EMPTY_VALUE)
     {
      //---   
      if(DrawType!=LINE)
        {
         buffer_data[s].low[i]   =EMPTY_VALUE;
         buffer_data[s].open[i]  =EMPTY_VALUE;
         buffer_data[s].high[i]  =EMPTY_VALUE;
        }
      buffer_data[s].close[i]=EMPTY_VALUE;
      return;
     }
//---          
   if(StartPriceDivergence==VERTICAL_LINE)
     {
      //---   
      divergence_time=(datetime)ObjectGetInteger(0,start_price_divergence,OBJPROP_TIME);
      //---    
      first_period_time=time[0];
     }
//---    ,     
   else
     {
      //---      ,      
      if(divergence_time==NULL)
        {
         ResetLastError();
         //---       
         for(int j=0; j<attempts; j++)
            if(CopyTime(Symbol(),timeframe_start_point,time[0]+PeriodSeconds(timeframe_start_point),1,period_time)==1)
              { ResetLastError(); break; }
         //---     /, 
         if(ArraySize(period_time)<1 || GetLastError()!=0)
            return;
         //---       
         else
            first_period_time=period_time[0];
        }
      //---        ,      
      if(time[i]<first_period_time)
         high_tf_time=first_period_time;
      //---             
      else
         high_tf_time=time[i];
      //---   
      ResetLastError();
      //---       
      for(int j=0; j<attempts; j++)
         if(CopyOpen(Symbol(),timeframe_start_point,high_tf_time,1,period_open)==1)
           { ResetLastError(); break; }
      //---       
      for(int j=0; j<attempts; j++)
         if(CopyTime(Symbol(),timeframe_start_point,high_tf_time,1,period_time)==1)
           { ResetLastError(); break; }
      //---     /, 
      if(ArraySize(period_open)<1 || ArraySize(period_time)<1 || GetLastError()!=0)
         return;
      //---     ,      
      //         ,   
      if(time[i]<first_period_time || divergence_time!=period_time[0])
        {
         symbol_difference[s]  =0.0; //    
         inverse_difference[s] =0.0; //   
         //---     
         divergence_time=period_time[0];
         //---     
         divergence_price=period_open[0];
         //---        
         CreateVerticalLine(0,0,period_time[0],start_price_divergence+"_"+TimeToString(divergence_time),
                            2,STYLE_SOLID,clrWhite,false,false,true,TimeToString(divergence_time),"\n");
        }
     }
//---         ,   
   if(StartPriceDivergence==VERTICAL_LINE && time[i]<divergence_time)
     {
      //---    
      symbol_difference[s]  =0.0;
      inverse_difference[s] =0.0;
      //---       
      if(DrawType==LINE)
         buffer_data[s].close[i]=rates[0].close-symbol_difference[s];
      //---      
      else
        {
         buffer_data[s].low[i]   =rates[0].low-symbol_difference[s];
         buffer_data[s].open[i]  =rates[0].open-symbol_difference[s];
         buffer_data[s].high[i]  =rates[0].high-symbol_difference[s];
         buffer_data[s].close[i] =rates[0].close-symbol_difference[s];
         //---      
         SetBufferColorIndex(i,s,rates[0].close,rates[0].open);
        }
     }
//---    
   else
     {
      //---     
      if(inverse[s])
        {
         //---    ,    
         if(symbol_difference[s]==0.0)
           {
            //---    
            if(StartPriceDivergence==VERTICAL_LINE)
              {
               //---  
               symbol_difference[s]  =rates[0].open-OC_open[i];
               inverse_difference[s] =OC_open[i]-(-OC_open[i]);
              }
            //---   
            else
              {
               //---  
               symbol_difference[s]  =rates[0].open-divergence_price;
               inverse_difference[s] =divergence_price-(-divergence_price);
              }
           }
         //---      
         if(DrawType==LINE)
            buffer_data[s].close[i]=-(rates[0].close-symbol_difference[s])+inverse_difference[s];
         //---     
         else
           {
            buffer_data[s].low[i]   =-(rates[0].low-symbol_difference[s])+inverse_difference[s];
            buffer_data[s].open[i]  =-(rates[0].open-symbol_difference[s])+inverse_difference[s];
            buffer_data[s].high[i]  =-(rates[0].high-symbol_difference[s])+inverse_difference[s];
            buffer_data[s].close[i] =-(rates[0].close-symbol_difference[s])+inverse_difference[s];
            //---      
            SetBufferColorIndex(i,s,rates[0].close,rates[0].open);
           }
        }
      //---   ,           
      else
        {
         //---    
         if(symbol_difference[s]==0.0)
           {
            //---    
            if(StartPriceDivergence==VERTICAL_LINE)
               symbol_difference[s]=rates[0].open-OC_open[i];
            //---   
            else
               symbol_difference[s]=rates[0].open-divergence_price;
           }
         //---       
         if(DrawType==LINE)
            buffer_data[s].close[i]=rates[0].close-symbol_difference[s];
         //---      
         else
           {
            buffer_data[s].low[i]   =rates[0].low-symbol_difference[s];
            buffer_data[s].open[i]  =rates[0].open-symbol_difference[s];
            buffer_data[s].high[i]  =rates[0].high-symbol_difference[s];
            buffer_data[s].close[i] =rates[0].close-symbol_difference[s];
            //---      
            SetBufferColorIndex(i,s,rates[0].close,rates[0].open);
           }
        }
     }
//---    
//         
   if(DrawType==LINE)
     {
      //---    ,     
      //           ,   
      if(time[i]!=rates[0].time || time[i]<first_period_time)
         buffer_data[s].close[i]=EMPTY_VALUE;
     }
//---     
   else
     {
      //---    ,     
      //            
      //      
      if(rates[0].time==NULL || 
         time[i]!=rates[0].time || 
         time[i]<first_period_time || 
         rates[0].low==EMPTY_VALUE || 
         rates[0].open==EMPTY_VALUE ||
         rates[0].high==EMPTY_VALUE ||
         rates[0].close==EMPTY_VALUE)
        {
         //---   
         buffer_data[s].low[i]   =EMPTY_VALUE;
         buffer_data[s].open[i]  =EMPTY_VALUE;
         buffer_data[s].high[i]  =EMPTY_VALUE;
         buffer_data[s].close[i] =EMPTY_VALUE;
        }
     }
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void SetBufferColorIndex(int i,int symbol_number,double close,double open)
  {
//---    ,  
   if(TwoColor)
     {
      //---      ,        
      if(close>open)
         buffer_data[symbol_number].icolor[i]=0;
      //---        
      else
         buffer_data[symbol_number].icolor[i]=1;
     }
//---   ,     /  
   else
      buffer_data[symbol_number].icolor[i]=0;
  }
//+------------------------------------------------------------------+
